#include <Wire.h>
#include <HX711_ADC.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define OLED_RESET 7 // we don't have a reset, but the constructor expects it 

#include <LiquidCrystal_I2C.h> // Vorher hinzugefügte LiquidCrystal_I2C Bibliothek einbinden
LiquidCrystal_I2C lcd(0x27, 16, 2);

Adafruit_SSD1306 display(OLED_RESET);
HX711_ADC LoadCell(4, 5);


byte interruptPin=3;
byte pumpenPin=2;
volatile bool taraRequest = false;
bool pumpenRequest = false;
bool Pumpelaeuft =false;


void setup()   {                
  pinMode(interruptPin, INPUT);
  pinMode(pumpenPin, INPUT);
  attachInterrupt(digitalPinToInterrupt(interruptPin), taraEvent, RISING);
  attachInterrupt(digitalPinToInterrupt(pumpenPin), pumpenEvent, FALLING);

  lcd.init(); //Im Setup wird der LCD gestartet 
lcd.backlight(); //Hintergrundbeleuchtung einschalten (lcd.noBacklight(); schaltet die Beleuchtung aus). 
//  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3C (for the 128x64)
//  display.clearDisplay();
//  display.setTextSize(1);
//  display.setTextColor(WHITE);

lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Bitte Warten");
lcd.setCursor(0, 1);
lcd.print("   START  ");
  
//  display.setCursor(10,4);
//  display.println("Wait");
//  display.display();
  LoadCell.begin();
  LoadCell.start(2000); 
  LoadCell.setCalFactor(1778.02); 
  
  pinMode(6, OUTPUT);
  digitalWrite(6,LOW);
}


void loop() {
  float weightAsFloat = 0.0;
  unsigned long t = 0;
  
  LoadCell.update();
  
  if (millis() > t + 250) {
    weightAsFloat = LoadCell.getData();
    displayWeight(weightAsFloat);
    t = millis();  
  }
  if(taraRequest){
    pumpenRequest==false;
    doTara();
    taraRequest = false;
  }
      if (pumpenRequest==false){
   digitalWrite(6,LOW);
     lcd.setCursor(0, 1);
lcd.print("                 ");
      }
      
 if (weightAsFloat > 50){
   
    if (pumpenRequest==true){
       digitalWrite(6,LOW);
//    display.setCursor(10,16);
//  display.println("Beendet");
//  display.display();

lcd.clear();
lcd.setCursor(0, 1);
lcd.print("Beendet          ");
      pumpenRequest=false;
      Pumpelaeuft =false;
  }}
  
 
  if (pumpenRequest==true){
        if (weightAsFloat < 50){
                    if (weightAsFloat <8){
                        
                        if (Pumpelaeuft == true){
                            pumpenRequest=false;
                            Pumpelaeuft =false;
                            digitalWrite(6,LOW);
                            lcd.clear();
                            lcd.setCursor(0, 1);
                            lcd.print("Beendet          ");
                            
                    }
      
         lcd.clear();
         lcd.setCursor(0, 1);
         lcd.print("Flasche eistellen");
         digitalWrite(6,LOW);
        }
  if (weightAsFloat > 7){
//    display.setCursor(10,16);
//  display.println("Pumpen");
//  display.display();

lcd.clear();
lcd.setCursor(0, 1);
lcd.print("Fuellen             ");
Pumpelaeuft = true;
    digitalWrite(6,HIGH);

    
    
  }
  }
  }
}

void displayWeight(float weight){
  String weightAsString = "";
  weightAsString = floatToDisplayString(weight);
//  display.clearDisplay();
//  display.setCursor(0,4);
//  display.println(weightAsString);
//  display.display();
  
  lcd.setCursor(0, 0);
lcd.print(weightAsString);

lcd.setCursor(6, 0);
lcd.print("                 ");
 
}


void doTara(){
  LoadCell.tareNoDelay();
//  display.clearDisplay();
//  display.setCursor(10,4);
//  display.println("Wait");
//  display.display();

lcd.clear();
lcd.setCursor(0, 0);
lcd.print("Bitte warten");
lcd.setCursor(0, 1);
lcd.print("  Kalibriert  ");

  while(LoadCell.getTareStatus()== false){
    LoadCell.update();
    delay(50);
    

  }
}



void taraEvent(){
 if (pumpenRequest==true){
   digitalWrite(6,LOW);
      pumpenRequest=false;
    }
  else{
  taraRequest = true;
  }
}

void pumpenEvent(){

   
  pumpenRequest = true;
  delay(250);
  
}

String floatToDisplayString(float floatValue){
  String stringValue=" ";
  int intValue = (int)(round(floatValue));
  if(intValue<0){
    stringValue="";
  }
  uint8_t blanks = 3 - int(log10(abs(intValue)));
  for(int i=0; i<blanks; i++){
    stringValue+=" ";
  }
  stringValue+=(String)intValue;
  return stringValue; 
}
